//MyMesh.h
#ifndef  __MYMESH_H
#define  __MYMESH_H

#include "MyVector2.h"
#include "MyVector3.h"

class	MyVertex;

class MyMesh
{
public:
	MyMesh();
	virtual ~MyMesh();

	//Create~~ ޽
	void			SetNumber(int iVertexCount, int iPrimitiveCount);
	int				GetVertexNumber();
	int				GetPrimitiveNumber();
		
	MyVector3*		GetVertexData();
	void			SetVertexData(MyVector3* pVertex);
	
	DWORD*			GetVertexColor();
	void			SetVertexColor(DWORD* pColor);

	MyVector3*		GetVertexNormal();
	void			SetVertexNormal(MyVector3* pNormal);

	MyVertex*		GetDeviceVertex();
	void			SetDeviceVertex(MyVertex* pMyVertex);

	MyVector2*		GetTextureUV();
	void			SetTextureUV(MyVector2* pUV);

	USHORT*			GetVertexIndex();
	int				GetVertexIndexCount();
	void			SetVertexIndex(int iCount, USHORT* pIndex);

protected:
	void		Release();

protected:
	MyVertex*	m_pDeviceVertex;

	int			m_iVertexCount;
	int			m_iPrimitiveCount;

	MyVector3*	m_pVertexData;
	DWORD*		m_pVertexColor;
	MyVector3*	m_pNormal;
	MyVector2*	m_pBaseUV;

	USHORT*		m_pVertexIndex;
	int			m_iIndexCount;
};



#endif