//MyVector3.h
#ifndef __MYVECOTOR3_H
#define __MYVECOTOR3_H

class MyVector3
{
public:
	float x, y, z;

	MyVector3();
    MyVector3(float _x, float _y, float _z);
	//operator  ڵ http://www.terathon.com/code/vector4d.php  C4Engine 
    const float&	operator[] (int i) const;
    float& operator[] (int i);
	// VECTOR = scalar * VECTOR
	MyVector3		operator *(float num) const;
    friend MyVector3 operator *(float num, const MyVector3& vec);
	// .
    float			operator *(const MyVector3& v) const;
    MyVector3&		operator =(const MyVector3& v);
    MyVector3		operator +(const MyVector3& v) const;
    MyVector3		operator -(const MyVector3& v) const;
	MyVector3&		operator +=(const MyVector3& v);
	MyVector3       operator /(float t) const;
	MyVector3&		operator /=(float t);
	MyVector3&		Normalize();
	MyVector3&		Cross(const MyVector3& v1, const MyVector3& v2);			
};

//u = ((P3  - P1) dot d)/(d dot d) = ((P3  - P1) dot d)/ (|| d||) 
//P3 Point̴
extern bool GetLengthLineAndPoint(const MyVector3& src, const MyVector3& dest, const MyVector3& point, float* fLength);

#endif