//MyVertexBuffer.h
#ifndef __MYVERTEXBUFFER_H
#define __MYVERTEXBUFFER_H


class   MyVertex;
class	MyIndexBuffer;

class MyVertexBuffer : public MyVertex
{
public:
    MyVertexBuffer();
    virtual ~MyVertexBuffer();

    bool CreateBuffer( IDirect3DDevice9* pDevice, UINT numVertices, DWORD FVF, UINT vertexSize, bool bDynamic = false );
    bool SetData( void *pVertices, DWORD flags = 0 );  
    void SetIndexBuffer( MyIndexBuffer* pIB );
    void Render( IDirect3DDevice9* pDevice, UINT numPrimitives, D3DPRIMITIVETYPE primitiveType );

private:
	void Release();

private:
    IDirect3DVertexBuffer9* m_pVB;
    MyIndexBuffer*          m_pMyIndexBuffer;
    UINT                    m_numVertices;
    UINT                    m_vertexSize;
    DWORD                   m_FVF;
};

#endif