//MyVector2.h
#ifndef __MYVECOTOR2_H
#define __MYVECOTOR2_H

class MyVector2
{
public:
	float x, y;

	MyVector2();
    MyVector2(float _x, float _y);
    const float&	operator[] (int i) const;
    float& operator[] (int i);
	// VECTOR = scalar * VECTOR
	MyVector2		operator *(float num) const;
    friend MyVector2 operator *(float num, const MyVector2& vec);
	// .
    float			operator *(const MyVector2& v) const;
    MyVector2&		operator =(const MyVector2& v);
    MyVector2		operator +(const MyVector2& v) const;
    MyVector2		operator -(const MyVector2& v) const;
	MyVector2&		operator +=(const MyVector2& v);
	MyVector2       operator /(float t) const;
	MyVector2&		operator /=(float t);
	MyVector2&		Normalize();
};

//u = ((P3  - P1) dot d)/(d dot d) = ((P3  - P1) dot d)/ (|| d||) 
//P3 Point̴
extern bool GetLengthLineAndPoint(const MyVector2& src, const MyVector2& dest, const MyVector2& point, float* fLength);

#endif