//xfile.h
#ifndef __CXFILE_H
#define __CXFILE_H

#include <vector>

class CDXEffect;

class CXFile
{
public:
	CXFile();
	virtual ~CXFile();

public:
	bool Load(IDirect3DDevice9* pDevice, char* szFileName);
	void Draw();
	void Release();

protected:
	bool SetAttribute(CDXEffect* pDXEffect, IDirect3DTexture9* pkTexture, D3DMATERIAL9* pkMaterial);

protected:
	IDirect3DDevice9*				m_pDevice;
	ID3DXMesh*                      m_pMesh;
	std::vector<D3DMATERIAL9>       m_materialContainer;
	std::vector<IDirect3DTexture9*> m_textureContainer;
	CDXEffect*						m_pDXEffect;
};



#endif